function [clus,clus_num]=cluster_nbc(data,K,dist_metric)


dlug = size(data,2);

C=cluster_distmtx(data,dist_metric);

% Okrelenie K - najbliszych ssiadw
KNN = zeros(dlug, K);
for i = 1 : dlug
    pom = C(i,:);
    % odrzuc ten sam punkt
    pom(i)=max(pom);
    [ps, inds]=sort(pom);
    KNN(i,:) = inds(1:K);
end

% Okrelenie Dense Point (DP) i Nearest Point (NP)
DP = zeros(1,dlug);
NP = zeros(dlug);
for i = 1 : dlug
    pom=find(KNN == i);
    if length(pom) >= K
        DP(i)=1;
        NP(i,KNN(i,:)) = 1; 
        NP(KNN(i,:),i) = 1;
    end
end

% Okrelenie klastrw
flag = zeros(1,dlug);
clus = zeros(1,dlug);
clus_num = 1;
for i = 1 : dlug
    if flag(i) == 0 && DP(i) == 1
        
        clus(i) = clus_num;
        flag(i) = 1;
        
        ind1=find(NP(i,:)==1);
        clus(ind1) = clus_num;
        flag(ind1) = 1;
        ind_clus = [i ind1];
        
        while length(ind1) > 0
            
            ind1_pom = [];
            for j = 1 : length(ind1)
                % Sprawdzaj wszystkie NP
                
                if DP(ind1(j)) == 1
                    % Analizuj dalej tylko jeli jest to DP
                    
                    ind1_tmp=find(NP(ind1(j),:)==1);
                    for k = 1 : length(ind1_tmp)
                        if length( find(ind1_tmp(k) == ind_clus)) == 0
                            % Porwnaj z obiektami klastra i dodaj nowy
                            % jeli jeszcze go nie byo 
                            ind1_pom = [ind1_pom ind1_tmp(k)];
                            ind_clus = [ind_clus ind1_tmp(k)];
                            clus(ind1_tmp(k)) = clus_num;   
                            flag(ind1_tmp(k)) = 1;  
                        end   
                    end 
                    
                end
              
            end
            ind1 = ind1_pom;
        end
        
        clus_num = clus_num + 1; 
    end
end
clus(find(clus==0))=max(clus)+1;
