function filter_classes;

size_x=285;
size_y=100;

Array_id=findobj('Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

class_count=max(get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData'));
if class_count==2
	enable_pairs='on';
else
	enable_pairs='off';
end;

Filter_id=findobj('Tag','FilterClasses');
if ~isempty(Filter_id)
	figure(Filter_id);
else
	Filter_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Filtracja klas', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','FilterClasses');

	hnd=uipanel('Parent',Filter_id, ...
		'Title','Parametry:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 280 65], ...
		'Tag','FilterPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 30 120 18], ...
		'String','Usu klasy z listy',...
		'Style','radio', ...
		'Value',1,...
		'Tag','DelListRadio',...
		'Callback','filter_classes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 5 130 18], ...
		'String','Pozostaw klasy z listy',...
		'Style','radio', ...
		'Value',0,...
		'Tag','KeepListRadio',...
		'Callback','filter_classes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[155 5 115 20], ...
		'String','Wczytaj list klas', ...
		'Tag','ListButt', ...
		'Enable','on',...
		'CallBack','filter_classes_cb(''load_list'')');

	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[205 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','FilterButt', ...
		'CallBack','filter_classes_cb(''filter'')');

	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[120 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf)');
end;
