function filter_classes_cb(action);

Array_id=findobj('Tag','ArrayView');
Filter_id=findobj('Tag','FilterClasses');
RadioHnd_id=findobj(Filter_id,'Style','radio');
radios_nr=length(RadioHnd_id);

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'radio'
		CurrentRadio_id=gcbo;
		for i=1:radios_nr
			if (RadioHnd_id(i)~=CurrentRadio_id)
				set(RadioHnd_id(i),'Value',0);
			else
				set(RadioHnd_id(i),'Value',1);
			end;
		end;

	case 'load_list'
		[fname,path,format]=uigetfile({'*.acn','Nazwy klas (*.acn)'; '*.*','Wszystkie pliki'},'Otwrz plik',config.open_path);

		file=[path,fname];
		if file~=0
			user_list=load_cell(file);
			if ~isempty(user_list) & min(size(user_list))==1
				set(Filter_id,'UserData',user_list);
			end;
		end;

	case 'filter'
		set(Filter_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');

		for i=1:radios_nr
			if get(RadioHnd_id(i),'Value')==1
				method=radios_nr-i+1;
				break;
			end;
		end;
		
		user_list=get(Filter_id,'UserData');
		if ~isempty(user_list)
			index=name2index(user_list,acnames);
			list=[];
			for i=1:length(index)
				list=[list;find(aorder==index(i))];
			end;

			if method==1
				data(:,list)=[];
				image_data(:,list)=[];
				anames(list)=[];
				aorder(list)=[];
			else
				data=data(:,list);
				image_data=image_data(:,list);
				anames=anames(list);
				aorder=aorder(list);
			end;
		else
			beep;
			warndlg('Lista klas nie zostaa wczytana','MStat');
			set(Filter_id,'Pointer','arrow');
			return;
		end;

		if isempty(data)
			beep;
			warndlg('Usunite wszystkie prbki','MStat');
			set(Filter_id,'Pointer','arrow');
			return;
		else
			switch questdlg(sprintf('Liczba prbek po filtacji: %d',size(data,2)),'MStat','Akceptuj','Anuluj','Akceptuj')
				case 'Anuluj'
					set(Filter_id,'Pointer','arrow');
					return;
				case 'Akceptuj'
					clist=1:length(acnames);
					acnames=acnames(clist(unique(aorder)));
					aorder=reorder_labels(aorder);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'Value',1,'UserData',acnames);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					set(Filter_id,'Pointer','arrow');
					delete(Filter_id);
			end;
		end;
end;
