function rollup_cb(action)

Array_id=findobj(0,'Tag','ArrayView');
Rollup_id=findobj(0,'Tag','Rollup');

RollupPop_id=findobj(Rollup_id,'Tag','RollupPop');
RollupMethodPop_id=findobj(Rollup_id,'Tag','RollupMethodPop');
RollupMinFeaturesEdit_id=findobj(Rollup_id,'Tag','RollupMinFeaturesEdit');
RollupMinNonmissingEdit_id=findobj(Rollup_id,'Tag','RollupMinNonmissingEdit');
RollupMinOverlapEdit_id=findobj(Rollup_id,'Tag','RollupMinOverlapEdit');
RollupGrubbsMinValEdit_id=findobj(Rollup_id,'Tag','RollupGrubbsMinValEdit');
RollupGrubbsPValThEdit_id=findobj(Rollup_id,'Tag','RollupGrubbsPValThEdit');
		
method_string={'mean';'median';'max';'r-rollup'};

switch action
	case 'check'
	
	case 'pop'
		
	case 'rollup'
		set(Array_id,'Pointer','watch');
		pause(0.01);
		set(Rollup_id,'Pointer','watch');
		pause(0.01);
		
		%pobieranie danych
		data=get(Array_id,'UserData');
		rollup_config=get(Rollup_id,'UserData');
		
		if (rollup_config.dim==1)
			order=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			names=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			cnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		else
			order=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
			cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
		end;

		rollup_config.method=method_string{get(RollupMethodPop_id,'Value')};
		rollup_config.min_features=str2num(get(RollupMinFeaturesEdit_id,'String'));
		rollup_config.min_nonmissing=str2num(get(RollupMinNonmissingEdit_id,'String'));
		rollup_config.min_overlap=str2num(get(RollupMinOverlapEdit_id,'String'));
		rollup_config.grubbs_min_values=str2num(get(RollupGrubbsMinValEdit_id,'String'));
		rollup_config.grubbs_p_th=str2num(get(RollupGrubbsPValThEdit_id,'String'));
		%rollup_config.log_base=10;
		
		%wykonanie rollup
		if get(RollupPop_id,'Value')==2
			[data,list,n]=data_rollup(data,name2order(names,' ('),rollup_config);
			%save_cell(gnames(aaaa),'merged.gnm');
		else
			[data,list,n]=data_rollup(data,order,rollup_config,cnames);
		end;

		%zwrocenie wynikow
		set(Array_id,'UserData',data);
		
		if (rollup_config.dim==1)
			if get(RollupPop_id,'Value')==1
				if length(cnames)==1 && strcmp(cnames(1),'Brak podziau na grupy')
					gnames={'rednia cech'};
				else
					[b,index]=unique(order,'first');
					groups_order=order(sort(index));

					gnames=cell(size(data,1),1);
					for i=1:length(groups_order)
						gnames{i}=cnames{groups_order(i)};
					end;
				end;
				gorder=ones(size(data,1),1);
				gcnames={'Brak podziau na grupy'};
			else
				gnames=names;
				gorder=order;
				
				gnames(list)=[];
				gorder(list)=[];
				if strcmp(questdlg('Czy usun nawiasy?','MStat','Tak','Nie','Tak'),'Tak')==1
					for i=1:length(gnames)
						gnames{i}=remove_from_name(gnames{i},' (');
					end;
				end;
				clist=1:length(cnames);
				gcnames=cnames(clist(unique(gorder)));
				gorder=reorder_labels(gorder);
			end;
			
			set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
			set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
			set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
		else
			order(list)=[];
			if length(cnames)==1 && strcmp(cnames(1),'Brak podziau na klasy')
				anames={'rednia prbek'};
			else			
				anames=cnames(order);
			end;
			
			set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
			set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',order);
		end;
		
		stat_struct.pval=NaN*ones(size(data,1),1);
		stat_struct.fdr=NaN*ones(size(data,1),1);
		stat_struct.fc=NaN*ones(size(data,1),1);
		if (rollup_config.dim==1)
			stat_struct.n=n;
		else
			stat_struct.n=ones(size(data,1),1);
		end;
		stat_struct.test='None';
		set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

		%aktualizacja gui
		mstat_cb('reset_view');
		mstat_cb('update_missing');
		mstat_cb('do_menu');
		mstat_cb('do_gui');

		mstat_cb('prepare_data');
		mstat_cb('prepare_axis');
		mstat_cb('redraw');

		%aktualizacja tabel
		GeneTable_id=findobj('Tag','GeneTable');
		if ~isempty(GeneTable_id)
			genes_table('create')
		end;
		ValueTable_id=findobj('Tag','ValueTable');
		if ~isempty(ValueTable_id)
			values_table('create')
		end;
		GroupTable_id=findobj('Tag','GroupTable');
		if ~isempty(GroupTable_id)
			groups_table('create')
		end;

		set(Rollup_id,'Pointer','arrow');
		set(Array_id,'Pointer','arrow');
		pause(0.01);
			
		delete(Rollup_id);
end;
