function [names,ids,column]=load_description(fname)

names=[];
ids=[];
column=-1;

[in_fid,msg]=fopen(fname,'r');
line=fgets(in_fid);
if (ischar(line)==1)
	header=tokenize_line_tab(line);
	column=get_order_name(header);


	
	if column>=1
		counter=1;
		names={};
		ids={};
		
		line=fgets(in_fid);
		while ischar(line)==1
			tokens=tokenize_line_tab(line);
			if length(tokens)>=column+1
				names{counter}=tokens{1};
				ids{counter}=tokens{column+1};

				counter=counter+1;
			end;
			line=fgetl(in_fid);
		end;
	end;
		
	names=names';
	ids=ids';
end;
fclose(in_fid);
return;
	
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function column=get_order_name(header)

column=0;
option=[];
if length(header)>0
	[column,OK]=listdlg('ListString',header,'SelectionMode','single','PromptString','Podzia:');
	if OK==0
		column=-1;
	end;
	
	pause(0.01);
end;
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function tokens=tokenize_line_tab(line)

tokens={};
counter=1;
token='0';
while ~isempty(token)
	[token,line]=strtok(line,'	');
	if ~isempty(token)
		tokens{counter}=deblank(token);
		counter=counter+1;
	end;
end;
return;