function missing_stat();

Array_id=findobj(0,'Tag','ArrayView');
ArrayAxes_id=findobj(Array_id,'Tag','ArrayAxes');
ArrayImage_id=findobj(get(ArrayAxes_id,'Children'),'Tag','ArrayImage');

AOrderAxes_id=findobj(Array_id,'Tag','ArrayClassAxes');
GOrderAxes_id=findobj(Array_id,'Tag','GeneClassAxes');

color=ctable();

data=get(Array_id,'UserData');
anames=get(SelectedArrayNameEdit_id,'UserData');
aorder=get(AOrderAxes_id,'UserData');
acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'String');

%zaleznosc mediany od liczby brakujcych wartoci po 
figure;
hold on;
for i=1:max(aorder)
	index=find(aorder==i);
	nan_index=isnan(data(:,index));
	p=100*(1-sum(nan_index)/size(data,1));
	m=nanmedian(data(:,index),1);

	[ps,ind]=sort(p);
	h=plot(ps,m(ind),'o');
	set(h,'Color',color(i,:));
end;
hnd=legend(acnames);
set(hnd,'FontName','Arial CE','FontSize',9,'FontWeight','bold');

set(gca,'FontName','Arial CE','FontSize',10,'FontWeight','bold');
xlabel('Procent wykrytych peptydw');
ylabel('Mediana sygnau');

%boxplot brakujacych wartosci
%nan_index=isnan(data);
%p=100*(1-sum(nan_index)/size(data,1));
%plot_box(p,aorder,acnames,'Procent wykrytych peptydw','Procent wykrytych peptydw');

%boxplot mediany
m=nanmedian(data,1);
plot_box(m,aorder,acnames,'Mediana sygnau','Mediana sygnau');

%histogramy

fig=figure('Units','pixels', ...
	'Visible','on',...
	'Position',[100 200 500 500],...
	'NumberTitle','off', ...
	'Resize','off',...
	'Color',[1 1 1],...
	'Name','Histogramy',...
	'Tag','HHist');

hold on;
for i=1:max(aorder)
	index=find(aorder==i);
	d=data(:,index);
	d=d(:);
	[tf,tx]=ksdensity(d(isnan(d)==0));

	hnd=plot(tx,tf);
	set(hnd,'Color',color(i,:),'LineWidth',1.5);
end;

set(gca,'FontName','Arial CE','FontSize',7,'XGrid','on','YGrid','on','Box','on');

xlabel('Bd RT');
ylabel('Gsto prawdopodobiestwa');

hnd=legend(acnames);
set(hnd,'FontName','Arial CE','FontSize',7);
