function a=data_smoothnorm(x,y,excluded,method,param)

not_excluded=[1:length(x)];
not_excluded(excluded)=[];

data_x=x(not_excluded);
data_y=y(not_excluded);

switch method
	case {'loess','rloess'}
		if method(1)=='r'
			s=loess(data_x,data_y,param,1,2);
		else
			s=loess(data_x,data_y,param,0,2);
		end;

	case {'lowess','rlowess'}
		if method(1)=='r'
			s=lowess(data_x,data_y,param,4);
		else
			s=lowess(data_x,data_y,param);
		end;

	otherwise
		p=polyfit(data_x,data_y,1);		
		s=polyval(p,data_x);	%yfit =  p(1) * x + p(2);
end;

a=y;
a(not_excluded)=a(not_excluded)-(s-x(not_excluded));

%[x,index]=sort(x);
%sm=[x';s(index)'];