function s=lowess(x,y,f,nsteps,delta);

if nargin==2
	f=0.2;
	nsteps=0;
	delta=0;
end;
if nargin==3
	nsteps=0;
	delta=0;
end;
if nargin==4
	delta=0;
end;

need_sort=0;
if any(diff(isnan(x))<0) | any(diff(x)<0)
	need_sort=1;
	[x,ind]=sort(x);
	y=y(ind);
end

s=clowess(x,y,f,nsteps,delta);

if need_sort==1
	s(ind)=s;
end;

