function [p,ctable]=chi_square(data,order)

x_groups=unique(data);
y_groups=unique(order);

ctable=zeros(length(x_groups),length(y_groups));

for i=1:length(x_groups)
	x_index=find(data==x_groups(i));
	for j=1:length(y_groups)
		ctable(i,j)=length(find(order(x_index)==y_groups(j)));
	end;
end;

e=sum(ctable')'*sum(ctable)/sum(sum(ctable));
X2=(ctable-e).^2./e;
X2=sum(sum(X2));
df=prod(size(ctable)-[1,1]);

p=1-chi2cdf(X2,df);