function sd=nan_sd(data,dim)

if nargin==1
	dim=-1;
end;

if dim==-1
	if (size(data,1)==1)
		dim=2;
	else
		dim=1;
	end;
end;

nan_index=isnan(data);

if dim==2
	sd=zeros(size(data,1),1);
	for i=1:size(data,1)
		index=find(nan_index(i,:)==0);
		if length(index)>0
	%		sd(i)=sqrt(var(data(i,index),1));
			sd(i)=std(data(i,index));
		else
			sd(i)=NaN;
		end;
	end;
else
	sd=zeros(1,size(data,2));
	for i=1:size(data,2)
		index=find(nan_index(:,i)==0);
		if length(index)>0
			sd(i)=std(data(index,i));
		else
			sd(i)=NaN;
		end;
	end;
end;