function selected=rfe(data,classes,selected_count)

%%%%%%%%%%%%%%%
%parametry SVM%
%%%%%%%%%%%%%%%
svm_c=1;
svm_shrinkage=0;

svm_model_params=sprintf('-q -s 0 -t 0 -c %f -h %d',svm_c,svm_shrinkage);

features_count=size(data,1);

ranking=ones(1,features_count);
features_index=1:features_count;

waitbar_hnd=waitbar(0,'Selekcja cech...');

%t = cputime;

for i=1:features_count
	
	%model=libsvmtrain(classes,data',svm_model_params);	
	cmodel=libsvm_train(data,classes,svm_model_params,true,false);
	
	w=libsvm_weights(cmodel.model);
	w=w.^2;
	if (size(w,2)>1)
		w=sum(w,2);
	end;
	
	[worst,worst_idx]=min(w);
	
	ranking(features_count-i+1)=features_index(worst_idx);
	data(worst_idx,:)=[];
	features_index(worst_idx)=[];

	waitbar(i/features_count,waitbar_hnd);
end;
%e = cputime-t

delete(waitbar_hnd);

selected=ranking(1:selected_count);