function mstat_mf()

Array_id=gcbf;
axis_id=findobj(Array_id,'Tag','ArrayAxes');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
view_struct=config.view_struct;

if gcf==Array_id
	AxesPosition=get(axis_id,'Position');
	CurrentPoint=get(Array_id,'CurrentPoint');
	x=CurrentPoint(1,1);
	y=CurrentPoint(1,2);

	block_size=config.view_struct.zoom;
	array_offset=config.view_struct.position_x;
	gene_offset=config.view_struct.position_y;

	if (x>AxesPosition(1) & x<AxesPosition(1)+AxesPosition(3) & y>AxesPosition(2) & y<AxesPosition(2)+AxesPosition(4))
		set(Array_id, 'Pointer', 'cross');
		axes(axis_id);
		pos_x=x-AxesPosition(1);
		pos_y=AxesPosition(4)+AxesPosition(2)-y;

		delete(findobj(get(axis_id,'Children'),'Type','text'));
		if pos_x>AxesPosition(1)+AxesPosition(3)-100
			pointer_shift_x=-100;
		else
			pointer_shift_x=5;
		end;

		aindex=array_offset+floor(pos_x/block_size);
		gindex=gene_offset+floor(pos_y/block_size);

		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');

		hnd=text(pos_x+pointer_shift_x,pos_y+30,sprintf('%s\n%s',anames{aindex},gnames{gindex}));
		set(hnd,'Color',[0 0 0],'BackgroundColor',[1 1 0.5],'FontSize',8,'FontWeight','bold','Interpreter','none','clipping','on');
	else
		set(Array_id, 'Pointer', 'arrow');
		delete(findobj(get(axis_id,'Children'),'Type','text'));
	end;
else
	delete(findobj(get(axis_id,'Children'),'Type','text'));
end;
