function [kD]=cluster_dbscan_plot(X,k,dist_metric)

if nargin==2
	dist_metric='euclidean';
end;

%TODO warunek na K

%zmienne
vectors_count=size(X,2);
k=min(k,vectors_count);

kD=zeros(1,vectors_count);

%TODO zmienics na cluster_distmtx
%macierz odleglosci
d=pdist(X',dist_metric);
d=squareform(d);

%wyznaczanie k-distance
%kD = pdist2(X',X','euc','Smallest',minPts); 
%kD=kD(end,:);
for i=1:vectors_count
    dnn=sort(d(i,:));
    kD(i)=dnn(k);
end;

%rysunek
figure('Units','pixels', ...
	'Visible','on',...
	'MenuBar','none', ...
	'Color',get(0,'defaultUicontrolBackgroundColor'),...
	'NumberTitle','off', ...
	'Resize','off',...
	'Tag','PlotDbscan',...
	'Name','DBSCAN');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

plot(sort(kD));


title(['k-distance graph (k = ' num2str(k) ')']);

%xlabel('Points sorted with 50th nearest distances')
%ylabel('50th nearest distances')
grid

