function d=cluster_distmtx(data,dist_metric)

if nargin==1
	dist_metric='euclidean';
end;

if strcmp(dist_metric,'spearman')==1 && str2double(version('-release'))<15
	warning off stats:pdist:APIChanged
	d=squareform(pdist(data',@speardist));
	warning on stats:pdist:APIChanged
else
	d=pdist(data',dist_metric);
end;
d=squareform(d);

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5%%%%%%%5
function d = speardist(XI,XJ)
d = 1-spear(XI',XJ');
return;