function [ch]=cluster_ch(data,order);

dimension=size(data,1);
vectors_count=size(data,2);

classes=unique(order);
classes_count=length(classes);

m=mean(data,2);
W=zeros(dimension,dimension);
B=zeros(dimension,dimension);
for i=1:classes_count
	index=find(order==classes(i));
	
	class_data=data(:,index);
	class_m=mean(class_data,2);
	class_data=class_data-repmat(class_m,1,length(index));
	W=W+class_data*class_data';
	B=B+length(index)*(class_m-m)*(class_m-m)';
end;

ch=(trace(B)/(classes_count-1))/(trace(W)/(vectors_count-classes_count))

S=zeros(dimension,dimension);
for i=1:classes_count
	index=find(order==classes(i));
	
	class_data=data(:,index);
	class_data=class_data-repmat(m,1,length(index));
	S=S+class_data*class_data';
end;
S
S=(data-repmat(m,1,vectors_count))*(data-repmat(m,1,vectors_count))'
T=B+W

%sum(diag(W))
%[c,D]=cluster_ord2centr(data,order);
