function save_arff(dataset,filename)

a=struct();		
for i=1:size(dataset.data,1)
	attr=struct('kind','numeric');
	attr.values=dataset.data(i,:);
    name=strrep(dataset.row_names{i},'+','_');
    name=strrep(name,'(','_');
    if name(end)==')'
        name=name(1:end-1);
    end;
    name=strrep(name,')','_');
    name=strrep(name,';','');
	eval(['a.' name ' = attr;']);
end;

classes=cell(size(dataset.data,2),1);
for i=1:length(classes)
	classes{i}=dataset.class_names{dataset.column_classes(i)};
end;

attr=struct();
attr.kind=dataset.class_names;
attr.values=classes;
a.class=attr;

arffparser('write',filename,a,remove_whitechar(dataset.name));

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nowhite_str=remove_whitechar(str)

nowhite_str='';
if ~isempty(str) & isstr(str)
	counter=1;
	for i=1:length(str)
		if isspace(str(i))==0
			nowhite_str(counter)=str(i);
			counter=counter+1;
		end;
	end;
%	nowhite_str=char(nowhite_str);
end;
return;
