function plot_iqr(data);

PlotMissing_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'Name','Rozkad brakujcych wartoci',...
			'KeyPressFcn',@figure_kb_cb,...			
			'Tag','PlotMissing');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

Array_id=findobj(0,'Tag','ArrayView');
data=get(Array_id,'UserData');

data=missing_filter(data,size(data,2)-1);
m=nanmean(data,2);
n=sum(isnan(data),2);
p=n./size(data,2);

[m,ind]=sort(m);
p=p(ind);

s=loess(m,p,0.4,1);

%m_grid=prctile(m,1:1:100);
m_grid=linspace(min(data(:)),max(data(:)),100);
c=zeros(1,length(m_grid));
for i=1:length(c)
	ind=find(m<m_grid(i));
	c(i)=median(p(ind));
end;

s2=loess(m_grid,c,0.4,1);

hold on;
%plot(m,p,'o');
plot(m,s,'k');
plot(m_grid,c,'ro');
plot(m_grid,s2,'g');

%set(gca,'XLim',[1 length(iqrange)],'FontSize',8,'box','on');
%xlabel('Numer cechy');
%ylabel('IQR');