function plot_sd(data);

PlotSD_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'Name','Posortowane wartoci SD/MEAN cech',...
			'KeyPressFcn',@figure_kb_cb,...			
			'Tag','PlotSD');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

Array_id=findobj(0,'Tag','ArrayView');
data=get(Array_id,'UserData');

sd=sqrt(var(data')')./mean(data,2);
[sd index]=sort(sd);
plot(sd);
set(gca,'XLim',[1 length(sd)],'FontSize',8,'box','on');
xlabel('Numer cechy');
ylabel('SD/MEAN');