function m=gmean(data,nonzero);

if nargin==1
	nonzero=1;
end;

if size(data,1)==1
	data=data';
end;

m=zeros(1,size(data,2));

if nonzero==0
	k=find(sum(data==0)==0);
	m(k)=exp(sum(log(data(:,k)))./size(data,1));
else
	for i=1:size(data,2)
		index=find(data(:,i)~=0);
		if length(index)~=0
			m(i)=exp(sum(log(data(index,i)))./length(index));
		end;
	end;
end;