function [t,p,d]=t_testp(data)

n=size(data,2)/2;
if 2*n==size(data,2)
	x=data(:,1:n)';
	y=data(:,n+1:2*n)';

	m_x=mean(x);
	m_y=mean(y);

	x=x-repmat(m_x,n,1);
	y=y-repmat(m_y,n,1);

	difference=m_x-m_y;
	s=sum((x-y).^2);
	
	t=difference*sqrt(n*(n-1));
	t=t./sqrt(s);

	if (nargout>1)
		p=1-tcdf(t,n-1);
		p=2*min(p,1-p);
		p=p';
	end;
else
	t=[];
	p=[];
	d=[];
end;