function order=name2order(names,group_str)

import com.mathworks.mwt.*;
import org.apache.commons.collections.*;

if nargin==1
	group_str=' (';
end;

nnames=cell(1);
for i=1:length(names)
	nnames{i}=remove_from_name(names{i},group_str);
end;

hash=MultiHashMap;
for i=1:length(nnames)
	hash.put(nnames{i},double(i)); 
end;

order=zeros(length(names),1);

iterator=hash.entrySet().iterator();
counter=1;
while iterator.hasNext()==1
	v=iterator.next().getValue();
	for i=1:v.size()
		order(v.get(i-1))=counter;
	end;
	counter=counter+1;
end;
return;
